/* ******************************************************************

   class    : AssertAction
   date     : 26.07.98
   compiler : javac (jdk 1.1.6)

*********************************************************************/

/* ******************************************************************
   import statements
*********************************************************************/

import java.awt.*;
import java.awt.event.ActionEvent;
import java.util.ResourceBundle;
import java.util.Properties;

import com.sun.java.swing.*;
import com.sun.java.swing.text.JTextComponent;

import Utils.ResourceUtil;
import Utils.FrameUtil;

/**
 * Inserts an assertion into the editor contained in frame.
 *
 * @author puehringer edgar
 */
class AssertAction extends AbstractAction {

  // class variable declarations
  private static final String ASSERT_ACTION = "assert";
  private static final String TITLE         = "AssertDlg.title";
  private static final String TEXT          = "AssertDlg.text";
  private static final String CONTENT1      = "AssertDlg.content1";
  private static final String CONTENT1ALT   = "AssertDlg.content1alt";
  private static final String CONTENT2      = "AssertDlg.content2";
  private static final String CONTENT2ALT   = "AssertDlg.content2alt";
  private static final String CONTENT3      = "AssertDlg.content3";

  // instance variable declarations
  protected Frame frame;
  protected ResourceBundle resources;
  protected Properties project;

  // constructors
  AssertAction(Frame frame, ResourceBundle resources, Properties project) {
    super(ASSERT_ACTION);
    this.frame     = frame;
    this.resources = resources;
    this.project   = project;
  } // end constructor AssertAction

  // methods
  public void actionPerformed(ActionEvent e) {
    CodepadPanel cpp;
    JTextComponent tk;
    String str;

    cpp = (CodepadPanel)FrameUtil.contains(frame,CodepadPanel.class);
    if (cpp == null) {
      System.err.println("AssertAction: CodepadPanel not found");
      return;
    } // end if
    tk  = cpp.getEditor();
    str = JOptionPane.showInputDialog(frame,
            ResourceUtil.getResStringOrKey(resources,TEXT),
            ResourceUtil.getResStringOrKey(resources,TITLE),
            JOptionPane.PLAIN_MESSAGE);
    if ((str != null) && !str.equals("")) {
      String s = project.getProperty(Const.CUR_ASSERT);
      if ((s == null) || s.equals(""))
        s = ResourceUtil.getResStringOrKey(resources,CONTENT1) +
            ResourceUtil.getResStringOrKey(resources,CONTENT2);
      else
        s = s + ResourceUtil.getResStringOrKey(resources,CONTENT1ALT) +
            s + ResourceUtil.getResStringOrKey(resources,CONTENT2ALT);
      // end if
      str = s + ' ' + str +
            ResourceUtil.getResStringOrKey(resources,CONTENT3);
      tk.replaceSelection(str);
    } // end if
  } // end actionPerformed

} // end AssertAction

/* ******************************************************************
   end of file
*********************************************************************/
