/* ******************************************************************

   class    : CloseAction
   date     : 22.07.98
   compiler : javac (jdk 1.1.6)

*********************************************************************/

/* ******************************************************************
   import statements
*********************************************************************/

import java.awt.*;
import java.awt.event.*;

/**
 *
 * Check if document must be saved and destroy the hosing frame.
 *
 * @author puehringer edgar
 *
 */
class CloseAction extends ExitAction {

  // instance variable declarations
  protected Frame frame;

  // constructors
  /** Create a new CloseAction class. */
  CloseAction(FrameManager fm, Frame frame) {
    super(fm,Const.CLOSE_ACTION);
    this.frame = frame;
  } // end constructor CloseAction

  // instance methods
  public void actionPerformed(ActionEvent e) {
    EventQueue eq = Toolkit.getDefaultToolkit().getSystemEventQueue();
    WindowEvent we;

    if (fm.getFrameCount() < 2) {
      super.actionPerformed(e);
    }
    else {
      we = new WindowEvent(frame,WindowEvent.WINDOW_CLOSING);
      eq.postEvent(we);
    } // end if
  } // end actionPerformed

} // end CloseAction

/* ******************************************************************
   end of file
*********************************************************************/
