/* ******************************************************************

   class    : SmartTextField
   date     : Sep 21 1998
   compiler : javac (1.1.6)

******************************************************************* */

package CustCtrl;

/* ******************************************************************
   import statements
******************************************************************* */

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * A TextField with automatic typeahead.
 *
 * @author puehringer edgar
 */
public class SmartTextField extends TextField implements KeyListener{

  // class variable declarations

  // instance variable declarations
  String[] strings;
  boolean caseSens;
  int pos;

  // constructors
  /** Create a new SmartTextField object. */
  public SmartTextField(String[] strings, boolean caseSens, int chars) {
    super(chars);
    this.strings  = strings;
    this.caseSens = caseSens;
    pos           = 0 ;
    addKeyListener(this);
    sortStrings();
 } // end constructor SmartTextField

  // class methods
  /* DEBUG ON */
  public static void main(String[] args) {
    Frame frame   = new Frame();
    String[] aStr = new String[3];

    aStr[0] = "Franz";
    aStr[1] = "Sepp";
    aStr[2] = "Hugo";
    frame.add(new SmartTextField(aStr,true,15));
    frame.show();
  } // end main
  /* DEBUG OFF */
  // methods
  void sortStrings() {
    for (int i=0; i<strings.length-1; i++) {
      boolean swaps = false;

      for (int j=strings.length-2; j>=i; j--) {
        if (strings[j].compareTo(strings[j+1]) > 0) {
          String temp = strings[j];

          strings[j]   = strings[j+1];
          strings[j+1] = temp;
          swaps        = true;
        }
      } // end for
      if (swaps == false) break;
    } // end for
  } // end sortStrings

  boolean validateText(int key) {
      String editField;

      pos       = getCaretPosition();
      editField = getText().substring(0,pos) + (char)key;
      if (!caseSens) editField = editField.toLowerCase();
      for (int i=0; i<strings.length; i++) {
        try {
          if (caseSens) {
            if(strings[i].startsWith(editField)) {
              setText(strings[i]);
              select(++pos,strings[i].length());
              return true;
            } // end if
          }
          else {
            if(strings[i].toLowerCase().startsWith(editField)) {
              setText(editField + strings[i].substring(editField.length()));
              select(++pos,strings[i].length());
              return true;
            } // end if
          } // end if
        } catch (Exception e) {
          // ignore any exception here
        }
      } // end for
      return false;
  } // end validateText

  // --- KeyListener ------------------------------------------------
  /** Invoked when a key has been typed. */
  public void keyTyped(KeyEvent e) {
    // do nothing
  } // end keyTyped

  /** Invoked when a key has been pressed. */
  public void keyPressed(KeyEvent e) {
    char key = e.getKeyChar();

    if ((key > 31) && (key < 127)) {
      if (validateText(key)) e.consume();
    } // end if
  } // end keyPressed

  /** Invoked when a key has been released. */
  public void keyReleased(KeyEvent e) {
    // do nothing
  } // end keyReleased


} // end SmartTextField

/* ******************************************************************
   end of file
******************************************************************* */
