/* ******************************************************************

   class    : KeywordAction
   date     : 22.07.98
   compiler : javac (jdk 1.1.6)

*********************************************************************/

/* ******************************************************************
   import statements
*********************************************************************/

import java.awt.*;
import java.awt.event.ActionEvent;

import com.sun.java.swing.*;

/**
 *
 * Starts a keyword search on the online help.
 *
 * @author puehringer edgar
 *
 */
class KeywordAction extends AbstractAction {

  // class variable declarations
  private static final String KEYWORD_ACTION = "keyword";

  // instance variable declarations
  private Frame frame;

  // constructors
  KeywordAction(Frame frame) {
    super(KEYWORD_ACTION);
    this.frame = frame;
  } // end constructor KeywordAction

  // instance methods
  public void actionPerformed(ActionEvent e) {
    AbstractHelpWindow wnd = AbstractHelpWindow.getHelpWindow(frame);
    Container c            = ((JFrame)frame).getContentPane();
    Component[] comp       = c.getComponents();
    CodepadPanel cpp       = null;
    String str;

    for (int i=0; i<comp.length; i++) {
      if (comp[i] instanceof CodepadPanel) {
        cpp = (CodepadPanel)comp[i];
        break;
      } // end if
    } // end for
    if (cpp == null) {
      System.err.println("KeywordAction: CodepadPanel not found");
      return;
    } // end if
    str = cpp.getWordAtCaretPos();
    if (str != null) wnd.showHelpOnKeyword(str);
      else Toolkit.getDefaultToolkit().beep();
  } // end actionPerformed

} // end KeywordAction

/* ******************************************************************
   end of file
*********************************************************************/
