/* ******************************************************************

   class    : AddFileMessage
   date     : 09.11.98
   compiler : javac (jdk 1.1.6)

*********************************************************************/

package Messages;

/* ******************************************************************
   import statements
*********************************************************************/

import java.io.File;

/**
 * A message that invokes the addition of a file to project file
 * list.
 *
 * @author puehringer edgar
 */
public class AddFileMessage extends Message {

  // constructors
  /** Create a new AddFileMessage object. */
  public AddFileMessage(File file) {
    super(file.getAbsolutePath());
  } // end constructor AddFileMessage

  // methods
  /** Get the file to add to the project file list. */
  public File getFile() {
    return new File(getDescription());
  } // end getFile

} // end AddFileMessage

/* ******************************************************************
   end of file
*********************************************************************/
